package stone;

import java.io.IOException;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;

public class UDPSender implements Runnable {
	private InetAddress toAddress;
	private int toPort;
	private String message;

	public UDPSender(InetAddress toAddress, int toPort, String message) {
		this.toAddress = toAddress;
		this.toPort = toPort;
		this.message = message;
	}

	public void run() {
		DatagramSocket socket;
		try {
			socket = new DatagramSocket();
		} catch (SocketException ex) {
			System.out.println("DatagramSocketの作成時にIOExceptinが発生しました。");
			return;
		}
		for (int count = 1; true; count++) {
			String messageWithCount = count + " " + message;
			System.out.println(messageWithCount + "を送信します。");
			try {
				socket.send(DatagramPacketFactory.create(toAddress, toPort,
						messageWithCount));
			} catch (IOException ex) {
				System.out
						.println(messageWithCount + "の送信時にIOExceptinが発生しました。");
				return;
			}
			System.out.println(messageWithCount + "を送信しました。");
			try {
				Thread.sleep(1000);
			} catch (InterruptedException ex) {
				System.out.println("sleep時にInterruptedExceptionが発生しました。");
				socket.close();
				return;
			}
		}
	}
}
